#include <stdio.h>
#include <math.h>
#include <gl/glut.h>

#define abs(a)	((a)<0 ? -(a) : (a))
#define sgn(a)	((a)<0 ? -1 : 1)

#define MAX_X 550
#define MAX_Y 450
#define MAX_UNOS 50

int xa, ya, xb, yb;

char unos_a[MAX_UNOS], unos_b[MAX_UNOS];
char *trenutni_unos;


void prikazLinije (int x, int y, int xb, int yb)
{
	int x0, y0;
	float f, xkorak, ykorak;

	glBegin (GL_POINTS);
	x0 = xb - x;
	y0 = yb - y;
	if (abs (x0) > abs (y0)) {
		xkorak = sgn (x0);
		ykorak = (float) (y0) / abs (x0);
		f = ykorak - (float) sgn (y0) / 2;
		while (x != xb) {
			if (sgn (f) == sgn (ykorak)) {
				y += sgn (y0);
				f -= sgn (y0);
			}
			glVertex2f (x, y);
			x += xkorak;
			f += ykorak;
		}
	} else {
		ykorak = sgn (y0);
		xkorak = (float) (x0) / abs (y0);
		f = xkorak - (float) sgn (x0) / 2;
		while (y != yb) {
			if (sgn (f) == sgn (xkorak)) {
				x += sgn (x0);
				f -= sgn (x0);
			}
			glVertex2f (x, y);
			y += ykorak;
			f += xkorak;
		}
	}
	glVertex2i (xb, yb);
	glEnd ();
}


void glLine (int xa, int ya, int xb, int yb)
{
	glBegin (GL_LINES);
	glVertex2i (xa, ya);
	glVertex2i (xb, yb);
	glEnd ();
}


void prikazTeksta (int x, int y, char *string1, char *string2)
{  
	char *c;
	glPushMatrix ();
	glRasterPos2i (x, y);
	for (c=string1; *c != '\0'; c++)
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13, *c);
	for (c=string2; c && *c != '\0'; c++)
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13, *c);
	if (string2 && string2 == trenutni_unos)
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13, '_');
	glPopMatrix ();
}


void obradaPrikaza (void)
{
	glClear (GL_COLOR_BUFFER_BIT);
	glColor3f (0.5, 0.5, 0.5);
	prikazTeksta (10, MAX_Y-13, "Molim x i y koordinate pocetne tocke: ", unos_a);
	if (trenutni_unos != unos_a)
		prikazTeksta (10, MAX_Y-26, "Molim x i y koordinate zavrsne tocke: ", unos_b);
	if (trenutni_unos == NULL) {
		glColor3f (0.0, 0.0, 0.0);
		prikazLinije (xa, ya, xb, yb);
		glLine (xa, ya+20, xb, yb+20);
	}
	glutSwapBuffers ();
}


void obradaTipke (unsigned char tipka, int x, int y)
{
	if (trenutni_unos != NULL) {
	
		if (((tipka >= '0' && tipka <= '9') || tipka == ' ') && strlen (trenutni_unos) < MAX_UNOS-1) {
			trenutni_unos[strlen(trenutni_unos)+1] = 0;
			trenutni_unos[strlen(trenutni_unos)] = tipka;
		}
		
		if (tipka == 8 && *trenutni_unos) {
			trenutni_unos[strlen(trenutni_unos)-1] = 0;
		}
		
		if (tipka == 13) {
			if (trenutni_unos == unos_b) {
				if (sscanf (unos_b, "%d %d", &xb, &yb) == 2)
					trenutni_unos = NULL;
				else
					*trenutni_unos = 0;
			}
			if (trenutni_unos == unos_a) {
				if (sscanf (unos_a, "%d %d", &xa, &ya) == 2)
					trenutni_unos = unos_b;
				*trenutni_unos = 0;
			}
		}
	}

	if (tipka == 27) {
		trenutni_unos = unos_a;
		trenutni_unos[0] = 0;
	}

	glutPostRedisplay ();
}


void obradaMisa (int gumb, int stanje, int x, int y)
{
	y = MAX_Y - y;

	if (gumb == GLUT_LEFT_BUTTON && stanje == GLUT_DOWN) {
		if (trenutni_unos == unos_b) {
			sprintf (unos_b, "%d %d", x, y);
			xb = x;
			yb = y;
			trenutni_unos = NULL;
		} else {
			sprintf (unos_a, "%d %d", x, y);
			xa = x;
			ya = y;
			trenutni_unos = unos_b;
			trenutni_unos[0] = 0;
		}
	}

	if (gumb == GLUT_RIGHT_BUTTON && stanje == GLUT_DOWN) {
		trenutni_unos = unos_a;
		trenutni_unos[0] = 0;
	}

	glutPostRedisplay ();
}


void main (int argc, char *argv[])
{
	trenutni_unos = unos_a;
	trenutni_unos[0] = 0;

	glutInit (&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE);
	glutInitWindowPosition (100, 100);
	glutInitWindowSize (MAX_X, MAX_Y);
	glutCreateWindow ("Laboratorijska vjezba 1");
	glOrtho (0, MAX_X, 0, MAX_Y, 0, 1); 
	glClearColor (1.0, 1.0, 1.0, 1.0);

	glutDisplayFunc (obradaPrikaza);
	glutKeyboardFunc (obradaTipke);
	glutMouseFunc (obradaMisa);
	glutMainLoop ();
}
